# Custom_Board-and-Gantry
Includes custom board files and gantry application. See documentation on how to run with Debug mode.


## Table of Contents

- [Overview](#overview)
- [Custom Board Files](#custom-board-files)
- [Debug Mode](#debug-mode-build-configuration-setting-for-newer-version-of-vs-code-and-nrf-development-kit)

## Overview

Includes the custom board files for the gantry system. Also includes some instructions on how to run debug mode for newer versions of nRF Connect and VS Code

## Custom Board Files

### DTS File

- [tricca_cboard.dts](tricca_cboard/tricca_cboard.dts)
- The tricca_cboard.dts is a  Device Tree Source defining the Tricca Custom Board's hardware configuration for Zephyr RTOS. It specifies memory allocations, flash partitioning, GPIO controller status, and key hardware features. This file is needed for interaction between Zephyr RTOS (nRF dev kit) and the Tricca CBoard components.

### DTSI File

- [tricca_cboard](tricca_cboard/tricca_cboard.dtsi)
- The tricca_cboard.dtsi file encapsulates pin configurations for communication peripherals in the Tricca CBoard. It defines settings for default and low-power sleep modes for I2C and UART interfaces. 

### Auto generated files by nRF Connect

- [Kconfig.board](tricca_cboard/Kconfig.board)
- [Kconfig.defconfig](tricca_cboard/Kconfig.defconfig)
- [board.cmake](tricca_cboard/board.cmake)
- [tricca_cboard.yaml](tricca_cboard/tricca_cboard.yaml)
- [tricca_cboard_defconfig](tricca_cboard/tricca_cboard_defconfig)

## Debug Mode Build Configuration Setting for newer version of VS code and nRF development kit
Scroll down for text.
![Image Alt Text](.vscode/build_config.jpg)












[Read the Full Documentation here:]((https://docs.google.com/document/d/1-0UyI5Ri5m08BzZfxcs9HFqkxXfKt6z6QK3W7IHYBD4/edit?usp=sharing)

```bash
# 1.) Go to nRF Connect on VS Code

# 2.) Edit the build configuration of the application.

# 3.) Select board “francis_board” or whatever the name of the custom board is.

# 4.) Add the correct overlay file. (e.g. francis_board.overlay)

# 5.) Select Configuration as prj.conf

# 6.) Select Optimization level as “Optimize for debugging (-Og)” or “Use project default”

# 7.) We can also do this by manually adding the following lines in our configuration file:
    #   CONFIG_DEBUG_OPTIMIZATIONS=y
    #   CONFIG_DEBUG_THREAD_INFO=y

# 8.) Select “Use sysbuild” when creating a build.
