/*
 * Copyright (c) 2016 Intel Corporation
 *
 * SPDX-License-Identifier: Apache-2.0
 */

#include <zephyr/kernel.h>
#include <zephyr/drivers/gpio.h>
#include <math.h>
#include "triccaboard.c"
#include "triccagantry.c"
#include "wellplateprotocols.c"
#include "gantrycontroller.c"

#define SLEEP_TIME_MS	1000
#define NUM_MOVES	3
#define M_PI		3.14159265358979323846
#define M_PI_2		1.57079632679489661923
#define M_PI_4		0.78539816339744830962

#define LED_PIN	1

#define NUM_BLINKS		10

int main(void)
{
	gpio_setup();

	for (int i = 0; i < NUM_BLINKS; i++) {
		// Toggle LED state
        k_msleep(500);
	    led_switch(0, 0);
		k_msleep(500);
	    led_switch(0, 1);
	}

    return 0;
}
