// Added January 17, 2024 by Francis.
/*
    These are the functions/declarations needed for getting the servo motor to work for our custom board. 
    The servoFunction() is a modified version of what Bryant used.
    The angleToPulseMap() is derived from the map() in the servo library for Arduino.
*/
#ifndef SERVO_H
#define SERVO_H

#include <zephyr/kernel.h>
#include <zephyr/drivers/gpio.h>


void timer_handler(struct k_timer *timer_id);

K_TIMER_DEFINE(my_timer, timer_handler, NULL);

long angleToPulseMap(long x, long angmin, long angmax, long pulmin, long pulout);

void servoFunction(int servoID, long angle, int pulseNum);

void executeAngleSequence(int angles[], int num_angles, int duration_ms, int pulseNum, int servoID);

void homeServo(int servoID, int homeAngle, int pulseNum);


#endif // SERVO_H