#ifndef TRICCABOARD_H
#define TRICCABOARD_H

#include <zephyr/kernel.h>
#include <zephyr/drivers/gpio.h>
#include <zephyr/drivers/i2c.h>

#define EX1_NODE DT_NODELABEL(ex1)
#define EX2_NODE DT_NODELABEL(ex2)
#define EX3_NODE DT_NODELABEL(ex3)
#define EX4_NODE DT_NODELABEL(ex4)
#define EX5_NODE DT_NODELABEL(ex5)
#define EX6_NODE DT_NODELABEL(ex6)
#define EX7_NODE DT_NODELABEL(ex7)
#define EX8_NODE DT_NODELABEL(ex8)
#define EX9_NODE DT_NODELABEL(ex9)
#define EX10_NODE DT_NODELABEL(ex10)
#define EX11_NODE DT_NODELABEL(ex11)
#define EX12_NODE DT_NODELABEL(ex12)
#define ENL_NODE DT_NODELABEL(enl)
#define MUX0_NODE DT_NODELABEL(mux0)
#define MUX1_NODE DT_NODELABEL(mux1)
#define MUX2_NODE DT_NODELABEL(mux2)
#define SMUX0_NODE DT_NODELABEL(smux0)
#define SMUX1_NODE DT_NODELABEL(smux1)
#define SMUX2_NODE DT_NODELABEL(smux2)
#define SMUX3_NODE DT_NODELABEL(smux3)
#define ENS_NODE DT_NODELABEL(ens)
#define CLKS_NODE DT_NODELABEL(clks)
#define STEPS_NODE DT_NODELABEL(steps)
#define DIRS_NODE DT_NODELABEL(dirs)
#define MMUX0_NODE DT_NODELABEL(mmux0)
#define MMUX1_NODE DT_NODELABEL(mmux1)
#define MMUX2_NODE DT_NODELABEL(mmux2)
#define CLKM_NODE DT_NODELABEL(clkm)
#define MISCM_NODE DT_NODELABEL(miscm)
#define LMUX0_NODE DT_NODELABEL(lmux0)
#define LMUX1_NODE DT_NODELABEL(lmux1)
#define LMUX2_NODE DT_NODELABEL(lmux2)
#define LMUX3_NODE DT_NODELABEL(lmux3)
#define LMT_NODE DT_NODELABEL(lmt)
#define SERV0_NODE DT_NODELABEL(serv0)
#define SERV1_NODE DT_NODELABEL(serv1)
#define SERV2_NODE DT_NODELABEL(serv2)
#define SERV3_NODE DT_NODELABEL(serv3)
#define TCA9548_NODE DT_NODELABEL(tca9548)
#define BH1749_NODE DT_NODELABEL(bh1749)

#define NUM_SENSORS 8
#define NUM_MOTORS 16
#define NUM_LIMIT_SWS 16
#define NUM_MISCS 8
#define NUM_SERVOS 4
#define NUM_LEDS 8

#define BH1749_ADDR 0x38
#define BH1749_ADDR_SYS_CTRL 0x40
#define BH1749_ADDR_MODE_CTRL1 0x41
#define BH1749_ADDR_MODE_CTRL2 0x42
#define BH1749_ADDR_RED 0X50
#define BH1749_ADDR_GREEN 0X52
#define BH1749_ADDR_BLUE 0X54
#define BH1749_ADDR_IR 0X58
#define BH1749_ADDR_GREEN2 0X5A
#define BH1749_ADDR_INT 0X60
#define BH1749_MAX_GAIN_MAX_INT 0x7B
#define BH1749_MODE_CTRL2_RGB_EN_ENABLE 0x10U

#define TCA9548_ADDR 0x70U

static const struct gpio_dt_spec ex1 = GPIO_DT_SPEC_GET_OR(EX1_NODE, gpios, {0});
static const struct gpio_dt_spec ex2 = GPIO_DT_SPEC_GET_OR(EX2_NODE, gpios, {0});
static const struct gpio_dt_spec ex3 = GPIO_DT_SPEC_GET_OR(EX3_NODE, gpios, {0});
static const struct gpio_dt_spec ex4 = GPIO_DT_SPEC_GET_OR(EX4_NODE, gpios, {0});
static const struct gpio_dt_spec ex5 = GPIO_DT_SPEC_GET_OR(EX5_NODE, gpios, {0});
static const struct gpio_dt_spec ex6 = GPIO_DT_SPEC_GET_OR(EX6_NODE, gpios, {0});
static const struct gpio_dt_spec ex7 = GPIO_DT_SPEC_GET_OR(EX7_NODE, gpios, {0});
static const struct gpio_dt_spec ex8 = GPIO_DT_SPEC_GET_OR(EX8_NODE, gpios, {0});
static const struct gpio_dt_spec ex9 = GPIO_DT_SPEC_GET_OR(EX9_NODE, gpios, {0});
static const struct gpio_dt_spec ex10 = GPIO_DT_SPEC_GET_OR(EX10_NODE, gpios, {0});
static const struct gpio_dt_spec ex11 = GPIO_DT_SPEC_GET_OR(EX11_NODE, gpios, {0});
static const struct gpio_dt_spec ex12 = GPIO_DT_SPEC_GET_OR(EX12_NODE, gpios, {0});
static const struct gpio_dt_spec enl = GPIO_DT_SPEC_GET_OR(ENL_NODE, gpios, {0});
static const struct gpio_dt_spec mux0 = GPIO_DT_SPEC_GET_OR(MUX0_NODE, gpios, {0});
static const struct gpio_dt_spec mux1 = GPIO_DT_SPEC_GET_OR(MUX1_NODE, gpios, {0});
static const struct gpio_dt_spec mux2 = GPIO_DT_SPEC_GET_OR(MUX2_NODE, gpios, {0});
static const struct gpio_dt_spec smux0 = GPIO_DT_SPEC_GET_OR(SMUX0_NODE, gpios, {0});
static const struct gpio_dt_spec smux1 = GPIO_DT_SPEC_GET_OR(SMUX1_NODE, gpios, {0});
static const struct gpio_dt_spec smux2 = GPIO_DT_SPEC_GET_OR(SMUX2_NODE, gpios, {0});
static const struct gpio_dt_spec smux3 = GPIO_DT_SPEC_GET_OR(SMUX3_NODE, gpios, {0});
static const struct gpio_dt_spec ens = GPIO_DT_SPEC_GET_OR(ENS_NODE, gpios, {0});
static const struct gpio_dt_spec clks = GPIO_DT_SPEC_GET_OR(CLKS_NODE, gpios, {0});
static const struct gpio_dt_spec steps = GPIO_DT_SPEC_GET_OR(STEPS_NODE, gpios, {0});
static const struct gpio_dt_spec dirs = GPIO_DT_SPEC_GET_OR(DIRS_NODE, gpios, {0});
static const struct gpio_dt_spec mmux0 = GPIO_DT_SPEC_GET_OR(MMUX0_NODE, gpios, {0});
static const struct gpio_dt_spec mmux1 = GPIO_DT_SPEC_GET_OR(MMUX1_NODE, gpios, {0});
static const struct gpio_dt_spec mmux2 = GPIO_DT_SPEC_GET_OR(MMUX2_NODE, gpios, {0});
static const struct gpio_dt_spec clkm = GPIO_DT_SPEC_GET_OR(CLKM_NODE, gpios, {0});
static const struct gpio_dt_spec miscm = GPIO_DT_SPEC_GET_OR(MISCM_NODE, gpios, {0});
static const struct gpio_dt_spec lmux0 = GPIO_DT_SPEC_GET_OR(LMUX0_NODE, gpios, {0});
static const struct gpio_dt_spec lmux1 = GPIO_DT_SPEC_GET_OR(LMUX1_NODE, gpios, {0});
static const struct gpio_dt_spec lmux2 = GPIO_DT_SPEC_GET_OR(LMUX2_NODE, gpios, {0});
static const struct gpio_dt_spec lmux3 = GPIO_DT_SPEC_GET_OR(LMUX3_NODE, gpios, {0});
static const struct gpio_dt_spec lmt = GPIO_DT_SPEC_GET_OR(LMT_NODE, gpios, {0});
static const struct gpio_dt_spec serv0_dev = GPIO_DT_SPEC_GET_OR(SERV0_NODE, gpios, {0});
static const struct gpio_dt_spec serv1_dev = GPIO_DT_SPEC_GET_OR(SERV1_NODE, gpios, {0});
static const struct gpio_dt_spec serv2_dev = GPIO_DT_SPEC_GET_OR(SERV2_NODE, gpios, {0});
static const struct gpio_dt_spec serv3_dev = GPIO_DT_SPEC_GET_OR(SERV3_NODE, gpios, {0});
static const struct i2c_dt_spec bh1749_dev = I2C_DT_SPEC_GET(BH1749_NODE);
static const struct i2c_dt_spec tca9548_dev = I2C_DT_SPEC_GET(TCA9548_NODE);

int gpio_setup();
void motor_setup();
int i2c_setup(); 
void motor_step(int motor, double stepNum, int dir, double delay_us);
void motor_switch(int motor, int en);

enum Mux_type {
    LIMIT,
    MOTOR,
    MISC,
    LED
};

enum Buttons {
    BTN0 = 0,
    BTN1,
    BTN2,
    BTN3,
    BTN4,
    BTN5,
    BTN6,
    BTN7,
    BTN8,
    BTN9,
    BTN10,
    BTN11,
    BTN12,
    BTN13,
    BTN14,
    BTN15
};

void mux_select(int num, enum Mux_type type);
void led_switch(int pos, int state);
long angleToPulseMap(long x, long angmin, long angmax, long pulmin, long pulout);
int button_status(enum Buttons btn);
void misc_switch(int pos, int state);
void mult_motors_step(int* motors, int numMotors, double stepNum, int dir, double delay_us);

#endif // TRICCABOARD_H