#ifndef WELLPLATEPROTOCOLS_H
#define WELLPLATEPROTOCOLS_H
#define WELL_DIST_X 9.0
#define WELL_DIST_Y -9.0
#define WELL_TOTAL 96

#include "triccagantry.h"

enum Well_Row {ROW_A=0, ROW_B, ROW_C, ROW_D, ROW_E, ROW_F, ROW_G, ROW_H, ROW_TOTAL};
enum Well_Col {COL_1=0, COL_2, COL_3, COL_4, COL_5, COL_6, COL_7, COL_8, COL_9, COL_10, COL_11, COL_12, COL_TOTAL};

#define MAX_PLATES 1
struct plates {
    struct gantry_coor coor;
};
struct plates WELL_PLATES[MAX_PLATES];

void (*WELL_FUNCS[96])(void); 
void well_plate_setup();
void travel_well_plate(struct plates plate);
void travel_well_pos(struct plates plate, enum Well_Col col, enum Well_Row row);

// Individual Well Functions
void dip_z_linear();
void dip_z_linear_slow();
void dip_z_linear_slower();
void dip_z_linear_slowest();
void dip_z_linear_fast();
void dip_z_double();
void dip_z_double_slow();
void dip_z_ramp_slow_fast();
void dip_z_ramp_fast_slow();
struct gantry_coor travel_circle(struct gantry_coor start_pos, double theta);

#endif // WELLPLATEPROTOCOLS_H